#ifndef CAM_COOKIE
#define CAM_COOKIE 49495923
#endif

//---- @interface section ----

@interface camera_t: NSObject	// Class: Parent
{
  int       cookie;
  NSString *name;
  int       pixel_dim[2];
  double    world_dim[2];
  vec_t    *view_point;
}

// + class methods

// - instance methods
  // constructors (overloaded)
- (id) init;

  // accessor/mutator
- (int) getpw;
- (int) getph;
- (double) getww;
- (double) getwh;
- (vec_t *) view_point;

  // operators

  // members
- (void) read: (FILE *) _file;
- (void) write: (FILE *) _file;

@end
