#ifndef bool
#define bool BOOL
#endif
#ifndef true
#define true YES
#endif
#ifndef false
#define false NO
#endif

//---- @interface section ----

@interface link_t: NSObject
{
  id     data;
  link_t *next;
}

// + class methods

// - instance methods
  // constructors (overloaded)
- (id)       init;
- (id)       init: (id) _data;
- (id)       init: (id) _data: (link_t *) _next;

  // accessor/mutator
- (id)       data;
- (link_t *) next;
- (void)     setnext: (link_t *) _next;
- (void)     setdata: (id) _data;

@end

@interface list_t: NSObject	// Class: Parent
{
  link_t *first;
  link_t *last;
  link_t *current;
}

// + class methods

// - instance methods
  // constructors (overloaded)
- (id)   init;

  // accessor/mutator
- (id)   data;

  // operators
- (void) add: (id) _data;
- (id)   pop;

  // members
- (void) reset;
- (bool) empty;
- (bool) end;
- (void) next;

- (id)   getbyname: (NSString *)_name;
- (void) write: (FILE *) _out;

@end
